
/*************************************************
	GLOBAL PROTOTYPES: msubutil.c
*************************************************/

#ifndef __msubutil_h
#define __msubutil_h

int
msub_overlapp(
#if NeedFunctionPrototypes
	msub *im,
	msub *jm
#endif
);

void
msub_area(
#if NeedFunctionPrototypes
	msub *im,
	int *x0,
	int *y0,
	int *x1,
	int *y1
#endif
);

void
clear_lev(
#if NeedFunctionPrototypes
	msub_list *lev
#endif
);

void
clear_ports(
#if NeedFunctionPrototypes
	port_list *ports
#endif
);

void
init_lev(
#if NeedFunctionPrototypes
	msub_list *lev
#endif
);

void
init_ports(
#if NeedFunctionPrototypes
	port_list *ports
#endif
);

void
poly_minmax(
#if NeedFunctionPrototypes
	Poly_list *plev,
	int x0,
	int y0,
	Rpoly *rpoly
#endif
);

int
cond_index(
#if NeedFunctionPrototypes
	Poly_list *plev,
	int x0,
	int y0
#endif
);

int
cond_index_min(
#if NeedFunctionPrototypes
	Poly_list *plev,
	int x0,
	int y0,
	Rtyp *R
#endif
);

void
rm_cov_msubs(
#if NeedFunctionPrototypes
	msub_list *lev
#endif
);

void
remove_msub(
#if NeedFunctionPrototypes
	msub *im,
	msub_list *lev
#endif
);

void
add_msub(
#if NeedFunctionPrototypes
	int id,
	int *ip,
	Box_info *Box,
	msub_list *lev
#endif
);

int
first_esub(
#if NeedFunctionPrototypes
	msub *ip,
	int *x0p,
	int *y0p,
	Rtyp *wp,
	sub_typ *sub
#endif
);

int
next_esub(
#if NeedFunctionPrototypes
	msub *ip,
	int *x0p,
	int *y0p,
	Rtyp *wp,
	sub_typ *sub
#endif
);

void
port2cir(
#if NeedFunctionPrototypes
	Cir *cir,
	Box_info *box
#endif
);

int
remove_port(
#if NeedFunctionPrototypes
	int x,
	int y,
	int ilev,
	port_list *ports
#endif
);

int
add_p_port(
#if NeedFunctionPrototypes
	int poly_index,
	int ipt,
	int ilev,
	int index,
	Rtyp *zp,
	port_list *ports,
	int line_nu
#endif
);

void
remove_p_port(
#if NeedFunctionPrototypes
	int poly_index,
	int ipt,
	int ilev,
	port_list *ports
#endif
);

void
portcpy(
#if NeedFunctionPrototypes
	port_typ *pa,
	port_typ *pb
#endif
);

int
max_inc(
#if NeedFunctionPrototypes
	Rtyp dx,
	int frac,
	Rtyp eeff,
	Rtyp freq
#endif
);

int
sub_size(
#if NeedFunctionPrototypes
	Rtyp dx,
	Rtyp dy,
	Rtyp *eps,
	Rtyp *mu,
	int nlev,
	Rtyp f
#endif
);

int
tour_msub(
#if NeedFunctionPrototypes
	Cir *cir
#endif
);

#endif  /* End: __msubutil_h */
